.686			
.mmx			
;k3d			
;.xmm			
.XMM
.model	flat, stdcall	 
option	casemap:none, language:stdcall, dotname
assume 	fs:nothing


include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\masm32.inc
include \masm32\include\msvcrt.inc
include \masm32\macros\macros.asm
include \masm32\macros\timers.asm
include \masm32\include\CpuId.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\masm32.lib
includelib \masm32\lib\msvcrt.lib


Main        proto

FJT2 proto
FJT3 proto
FJT4 proto
BMLinDD proto	:DWORD, :DWORD,:DWORD
BMLinDW proto	:DWORD, :DWORD,:DWORD
BMLinDB proto	:DWORD, :DWORD,:DWORD
InstrJJ proto	:DWORD, :DWORD,:DWORD,:DWORD

;	Usage:
;	timings InString, 1, addr MainString, addr SubString
timings MACRO algo, a1, a2, a3, a4, a5, a6
LOCAL tmp$, out$, Description
  ifndef LOOP_COUNT
	LOOP_COUNT = 1000000	;; default: one Million
  endif
  ifndef CurAlgo
  	CurAlgo equ <>
  endif
  ifdif CurAlgo, <algo>
  	CurAlgo equ <algo>
  endif
  Description equ CurAlgo

  tmp$ CATSTR <invoke >, <algo>
  ifnb <a1>
	tmp$ CATSTR tmp$, <, >, <a1>
	Description CATSTR Description, <, >, <a1>
  ifnb <a2>
	tmp$ CATSTR tmp$, <, >, <a2>
	Description CATSTR Description, <, >, <a2>
  ifnb <a3>
	tmp$ CATSTR tmp$, <, >, <a3>
	Description CATSTR Description, <, >, <a3>
  ifnb <a4>
	tmp$ CATSTR tmp$, <, >, <a4>
	Description CATSTR Description, <, >, <a4>
  ifnb <a5>
	tmp$ CATSTR tmp$, <, >, <a5>
	Description CATSTR Description, <, >, <a5>
  endif
  endif
  endif
  endif
  endif
  ifndef globcycles		;; we might need to calculate a global average count
  	.data?
  	globcycles	dd ?
  	globcount	dd ?
  	.code
  endif
  ifndef REP_CT
	REP_CT = 1
  endif
  ifndef REP_CTold
	REP_CTold = REP_CT
  endif
  if REP_CT gt 1
  	if REP_CTold eq 1
		print chr$(13, 10)
	endif
	REP_CTold = REP_CT
  endif
  ;% echo tmp$			;; uncomment to see what exactly you are invoking
  REPEAT REP_CT
	invoke Sleep, 50
	push esi
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		tmp$
		mov esi, eax
	counter_end
	add globcycles, eax
	inc globcount
	out$ CATSTR <print str$(eax), 9, ">, Description, <", 9, "res=">
	out$
	print str$(esi), 13, 10
	pop esi
  ENDM
  if REP_CT gt 1
	print chr$(13, 10)
  endif
ENDM

.data


align 4

  LOOP_COUNT    EQU	500000/100
  MINUS_1       EQU 0ffffffffH

  SzBMI1         db "FJT2 Cresta/IanB,  byte-length shifts: ",0
  SzBMI2         db "FJT3 Cresta/IanB,  word-length shifts: ",0
  SzBMI3         db "FJT4 Cresta/IanB, dword-length shifts: ",0
  SzLingo        db "Boyer-Moore Lingo,dword-length shifts: ",0
  SzLingoDW  db "Boyer-Moore Lingo, word-length shifts: ",0
  SzLingoDB  db "Boyer-Moore Lingo, byte-length shifts: ",0


  ; matchlen 10, sourcelen 50
  ; with optimisations, the Boyer-Moore is now only half as slow as the
  ; word scanner for short searches
    SzTest1        db "Short test with match string at end: Here it is!",13,10,0
    SzMatch1       db "Here it is",0  
    SzResult1      db 13,10,"Search Test 1 - value expected 37",13,10,0

  ; matchlen 17, sourcelen 1024
  ; deliberately difficult, every position must be tested with this match start
  SzTest2        db 1007 dup ("M"), "MMMMMMhardMMMMMMM", 0
  SzMatch2       db "MMMMMMhardMMMMMMM",0  
  SzResult2      db 13,10,"Search Test 2 - value expected 1007",13,10,0

  ; matchlen 16, sourcelen 1024
  ; pattern very different from background
  SzTest3        db 1008 dup ("M"), "Should be easier", 0
  SzMatch3       db "Should be easier",0  
  SzResult3      db 13,10,"Search Test 3 - value expected 1008",13,10,0

  ; matchlen 16, sourcelen 1024
  ; BinSearch seems to have advantage for longer match lengths 
  SzTest4        db 72 dup ("Many repetitio"), "Many repetitions", 0
  SzMatch4       db "Many repetitions", 0 
  SzResult4      db 13,10,"Search Test 4 - value expected 1008",13,10,0

  ; matchlen 16, sourcelen 1024
  ; BinSearch can't seem to take advantage of the earlier match failure 
  SzTest5        db 72 dup ("Many repeatsns"), "Many repetitions", 0
  SzMatch5       db "Many repetitions", 0 
  SzResult5      db 13,10,"Search Test 5 - value expected 1008",13,10,0

  ; matchlen 16, sourcelen 1024
  ; serious disadvantage for Boyer-Moore for this close repeating pattern
  ; as all the repeats must check from the matching end almost to the start
  SzTest6        db 72 dup ("No repetitions"), "Many repetitions", 0
  SzMatch6       db "Many repetitions", 0
  SzResult6      db 13,10,"Search Test 6 - value expected 1008",13,10,0

  ; matchlen 14, sourcelen 1024
  ; more random text, BInStrWithLen catching up with Boyer-Moore
  SzTest7        db "The three algorithms are variations of a Boyer Moore design. "
                 db "The original design BMBinSearch is the most flexible across different search conditions. "
                 db "The two variations BMHBinsearch and SBMBinSearch are respectively a Horspool variation "
                 db "and a simplified variation which perform well depending on the hardware and the "
                 db "patterns being searched. The minimum pattern length is 2 bytes but these algorithms are "
                 db "slower on very short patterns than a classic byte scanner. The algorithms have about a "
                 db "300 character penalty at startup as they must construct a table so for either very "
                 db "short patterns or short data it is more efficient to use a byte scanner. "
                 db "The three algorithms are variations of a Boyer Moore design. "
                 db "The original design BMBinSearch is the most flexible across different search conditions. "
                 db "The two variations BMHBinsearch and SBMBinSearch are respectively a Horspool variation "
                 db "and a simplified variation which perform well depending on the hardware and the "
                 db "patterns being searched. Basic text, few or no repetitions", 0
; SzMatch7       db "no re",0  
SzMatch7       db "no repetitions",0  
SzResult7      db 13,10,"Search Test 7 - value expected 1009",13,10,0

.data?
align 16
tabl qword  64*16 Dup(?)
align 16

  ShiftTable     DWORD 256 DUP (?)


fbuffer	dd ?
flen	dd ?

matchlen	dd ?
sourcelen	dd ?

.code
FindInWinInc	db "Duplicate inc", 0

Start:
	Invoke	Main
	inkey "-----  Press any key to exit... -----"
	Invoke	ExitProcess, 0

Main    proc

	invoke ShowCPU, 1

	print chr$(13,10,13,10, "Finding '")
	print offset FindInWinInc, "' at the end of \masm32\include\windows.inc:", 13, 10

	call WinInc

	print chr$(13, 10, "--- WinInc done, press Ctrl C to stop here ---", 13, 10)
	getkey
	; exit

        push    ebx
        push    edi
        ; mov     eax, input("Please terminate any high-priority tasks and press ENTER to begin...")
        print   chr$("String search tests:",13,10)
        print   addr SzResult1

        print   addr SzBMI1
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 10  ; matchlen
        mov     edx, 50  ; sourcelen
        lea     ecx, SzMatch1
        lea     ebp, SzTest1
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 10  ; matchlen
        mov     edx, 50  ; sourcelen
        lea     ecx, SzMatch1
        lea     ebp, SzTest1
        xor     ebx, ebx ; startpos
        invoke  FJT3
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI3
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 10  ; matchlen
        mov     edx, 50  ; sourcelen
        lea     ecx, SzMatch1
        lea     ebp, SzTest1
        xor     ebx, ebx ; startpos
        invoke  FJT4
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

		print   addr SzLingoDB
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BMLinDB, addr SzTest1, addr SzMatch1, 10  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

		print   addr SzLingoDW
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BMLinDW, addr SzTest1, addr SzMatch1, 10  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

  		print   addr SzLingo
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BMLinDD, addr SzTest1, addr SzMatch1, 10  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

	timings InString, 1, addr SzTest1, addr SzMatch1
	timings InstrJJ, 1, addr SzTest1, addr SzMatch1, 0

        print   addr SzResult2, 13, 10

        print   addr SzBMI1
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 17  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch2
        lea     ebp, SzTest2
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 17  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch2
        lea     ebp, SzTest2
        xor     ebx, ebx ; startpos
        invoke  FJT3
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI3
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 17  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch2
        lea     ebp, SzTest2
        xor     ebx, ebx ; startpos
        invoke  FJT4
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250


		print   addr SzLingoDB
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BMLinDB, addr SzTest2, addr SzMatch2, 17  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzLingoDW
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BMLinDW, addr SzTest2, addr SzMatch2, 17  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzLingo
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BMLinDD, addr SzTest2, addr SzMatch2, 17  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

	timings InString, 1, addr SzTest2, addr SzMatch2
	timings InstrJJ, 1, addr SzTest2, addr SzMatch2, 0

        print   addr SzResult3

        print   addr SzBMI1
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch3
        lea     ebp, SzTest3
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch3
        lea     ebp, SzTest3
        xor     ebx, ebx ; startpos
        invoke  FJT3
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI3
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch3
        lea     ebp, SzTest3
        xor     ebx, ebx ; startpos
        invoke  FJT4
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250


		print   addr SzLingoDB
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BMLinDB, addr SzTest3, addr SzMatch3, 16  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzLingoDW
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
         invoke  BMLinDW, addr SzTest3, addr SzMatch3, 16  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzLingo
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        invoke  BMLinDD, addr SzTest3, addr SzMatch3, 16  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

	timings InString, 1, addr SzTest3, addr SzMatch3
	timings InstrJJ, 1, addr SzTest3, addr SzMatch3, 0

        print   addr SzResult4

        print   addr SzBMI1
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch4
        lea     ebp, SzTest4
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch4
        lea     ebp, SzTest4
        xor     ebx, ebx ; startpos
        invoke  FJT3
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI3
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch4
        lea     ebp, SzTest4
        xor     ebx, ebx ; startpos
        invoke  FJT4
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250



		print   addr SzLingoDB
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
         invoke  BMLinDB, addr SzTest4, addr SzMatch4, 16  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzLingoDW
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
         invoke  BMLinDW, addr SzTest4, addr SzMatch4, 16  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzLingo
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
         invoke  BMLinDD, addr SzTest4, addr SzMatch4, 16  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250
	timings InString, 1, addr SzTest4, addr SzMatch4
	timings InstrJJ, 1, addr SzTest4, addr SzMatch4, 0

        print   addr SzResult5

        print   addr SzBMI1
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch5
        lea     ebp, SzTest5
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch5
        lea     ebp, SzTest5
        xor     ebx, ebx ; startpos
        invoke  FJT3
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI3
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch5
        lea     ebp, SzTest5
        xor     ebx, ebx ; startpos
        invoke  FJT4
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250



        print   addr SzLingoDB
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
         invoke  BMLinDB, addr SzTest5, addr SzMatch5, 16  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzLingoDW
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
         invoke  BMLinDW, addr SzTest5, addr SzMatch5, 16  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzLingo
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
         invoke  BMLinDD, addr SzTest5, addr SzMatch5, 16  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

	timings InString, 1, addr SzTest5, addr SzMatch5
	timings InstrJJ, 1, addr SzTest5, addr SzMatch5, 0


        print   addr SzResult6

        print   addr SzBMI1
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch6
        lea     ebp, SzTest6
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch6
        lea     ebp, SzTest6
        xor     ebx, ebx ; startpos
        invoke  FJT3
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI3
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 16  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch6
        lea     ebp, SzTest6
        xor     ebx, ebx ; startpos
        invoke  FJT4
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250


        print   addr SzLingoDB
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
         invoke  BMLinDB, addr SzTest6, addr SzMatch6, 16  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzLingoDW
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
         invoke  BMLinDW, addr SzTest6, addr SzMatch6, 16  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzLingo
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
         invoke  BMLinDD, addr SzTest6, addr SzMatch6, 16  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250
	timings InString, 1, addr SzTest6, addr SzMatch6
	timings InstrJJ, 1, addr SzTest6, addr SzMatch6, 0

        print   addr SzResult7

        print   addr SzBMI1
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 14  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch7
        lea     ebp, SzTest7
        xor     ebx, ebx ; startpos
        invoke  FJT2
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI2
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 14  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch7
        lea     ebp, SzTest7
        xor     ebx, ebx ; startpos
        invoke  FJT3
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzBMI3
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
        mov     eax, 14  ; matchlen
        mov     edx, 1024  ; sourcelen
        lea     ecx, SzMatch7
        lea     ebp, SzTest7
        xor     ebx, ebx ; startpos
        invoke  FJT4
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250


        print   addr SzLingoDB
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
         invoke  BMLinDB, addr SzTest7, addr SzMatch7, 14  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzLingoDW
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
         invoke  BMLinDW, addr SzTest7, addr SzMatch7, 14  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)
        print   chr$(13,10)
        invoke  Sleep, 250

        print   addr SzLingo
        push    ebp
        counter_begin   LOOP_COUNT, HIGH_PRIORITY_CLASS
         invoke  BMLinDD, addr SzTest7, addr SzMatch7, 14  
        mov     edi, eax
        counter_end
        pop     ebp
        mov     ebx, eax
        print   ustr$(edi)
        print   chr$(" ; clocks: ")
        print   ustr$(ebx)

        print   chr$(13,10)
	timings InString, 1, addr SzTest7, addr SzMatch7
	timings InstrJJ, 1, addr SzTest7, addr SzMatch7, 0

        pop     edi
        pop     ebx
        ret

Main	EndP

; ------------------------------------------------------------------------------

align 16

FJT2	proc

 comment    * -----------------------------------------------------------------------------
            BM by Cresta rewritten by IanB to use the same entry and exit protocols as
            BInStrWithLen, optimisations including the use of the .DATA? section for the
            ShiftTable, as the extra indexing is slower. Also restricted search string
            to 255 chars, allowing byte-length shifts and a 256-byte shift table.

            On entry:
                EAX = match_len (must be >= 2 and < 255)
                ECX = lpMatch, pointer to test string
                EDX = DataLen
                EBP = lpData, pointer to source array
                EBX = StartPos offset in lpData
            On exit:
                EAX = string position (from start of source array) or -1 if not found
                EDX = match_len
            EBX/EBP/EDI/ESI are preserved.
            ----------------------------------------------------------------------------- *

        push    esi
        push    edi
        push    eax
        push    ebx
        push    ebp

        cmp     eax, 2                  ; string too short, must be > 1
        jb      no_match
        cmp     eax, 254                ; string too long, must be < 254
        ja      no_match

        add	    edx, ebp
        add     ebp, ebx                ; EBP = lpData (including startpos offset if any)
        lea     edi, ShiftTable
        mov     ebx, eax                ; EBX = match_len
        sub	    edx, eax
        add     eax, 1
        mov     esi, ecx                ; ESI = lpMatch
        and     ebx, 0fffffffcH         ; remove remainder bytes over DWORD count
        add     edx, 1                  ; EDX = lpData+DataLen-match_len+1
        mov     ecx, 256
        rep     stosb                   ; fill ShiftTable with match_len+1

        mov     edi, esi
        sub     eax, 1                  ; EAX = match_len
        sub     ebx, 4                  ; EBX = 4 * (count of DWORDs in match string - 1)

put_offset:
        movzx   ecx, BYTE PTR [edi]
        add     edi, 1
        mov     BYTE PTR ShiftTable[ecx], al
        sub     al, 1
        jnz     put_offset

        mov     eax, [esi]              ; get first DWORD to compare
        mov     edi, ebp                ; EDI = lpData + startpos
        mov     ebp, [esp+8]            ; EBP = match_len
        push    ebx                     ; save DWORD counter

align 4    

first_dword:
        movzx   ecx, BYTE PTR [edi+ebp]
        cmp     eax, [edi]
        jne     @F

align 4

scan_dword:
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        jmp     scan_dword

align 4 

@@:
        movzx   ecx, BYTE PTR ShiftTable[ecx]
        mov     eax, [esi]              ; get first DWORD to compare
        add     edi, ecx
        mov     ebx, [esp]              ; restore DWORD counter
        cmp     edi, edx                ; check for end of data
        jle     first_dword

no_match:
        or      eax, MINUS_1
        pop     ecx                     ; dump DWORD count
        pop     ebp
        jmp     @Ret

last_bytes:
        mov     ecx, 0fffffffcH
        mov     ebx, ebp
        and     ecx, ebp
        sub     ebx, ecx                ; match_len - whole DWORDs matched so far
        add     esi, ecx
        add     edi, ecx
@@:
        mov     al, BYTE PTR [esi+ebx-1]
        sub     ebx, 1
        js      found
        cmp     [edi+ebx], al
        je      @B

        sub     edi, ecx
        sub     esi, ecx
        add     edi, 1
        mov     eax, [esi]              ; get first DWORD to compare
        mov     ebx, [esp]              ; restore DWORD counter
        jmp     first_dword
    
found:
        pop     edx                     ; dump DWORD count
        sub     edi, ecx
        pop     ebp
        mov     eax, edi
        sub     eax, ebp
@Ret:
        pop     ebx
        pop     edx                     ; return match_len in EDX
        pop     edi
        pop     esi
        ret                             ; return offset of string or -1 if not found

FJT2 endp

; ------------------------------------------------------------------------------

align 16

FJT3	proc

 comment    * -----------------------------------------------------------------------------
            BM by Cresta rewritten by IanB to use the same entry and exit protocols as
            BInStrWithLen, optimisations including the use of the .DATA? section for the
            ShiftTable, as the extra indexing is slower. Also restricted search string
            to 64K chars, allowing word-length shifts and a 256-word shift table.

            On entry:
                EAX = match_len (must be >= 2 and < 65535)
                ECX = lpMatch, pointer to test string
                EDX = DataLen
                EBP = lpData, pointer to source array
                EBX = StartPos offset in lpData
            On exit:
                EAX = string position (from start of source array) or -1 if not found
                EDX = match_len
            EBX/EBP/EDI/ESI are preserved.
            ----------------------------------------------------------------------------- *

        push    esi
        push    edi
        push    eax
        push    ebx
        push    ebp

        cmp     eax, 2                  ; string too short, must be > 1
        jb      no_match
        cmp     eax, 65534              ; string too long, must be < 65535
        ja      no_match

        add	    edx, ebp
        add     ebp, ebx                ; EBP = lpData (including startpos offset if any)
        lea     edi, ShiftTable
        mov     ebx, eax                ; EBX = match_len
        sub	    edx, eax
        add     eax, 1
        mov     esi, ecx                ; ESI = lpMatch
        and     ebx, 0fffffffcH         ; remove remainder bytes over DWORD count
        add     edx, 1                  ; EDX = lpData+DataLen-match_len+1
        mov     ecx, 256
        rep     stosw                   ; fill ShiftTable with match_len+1

        mov     edi, esi
        sub     eax, 1                  ; EAX = match_len
        sub     ebx, 4                  ; EBX = 4 * (count of DWORDs in match string - 1)

put_offset:
        movzx   ecx, BYTE PTR [edi]
        add     edi, 1
        mov     WORD PTR ShiftTable[ecx+ecx], ax
        sub     ax, 1
        jnz     put_offset

        mov     eax, [esi]              ; get first DWORD to compare
        mov     edi, ebp                ; EDI = lpData + startpos
        mov     ebp, [esp+8]            ; EBP = match_len
        push    ebx                     ; save DWORD counter

align 4    

first_dword:
        movzx   ecx, BYTE PTR [edi+ebp]
        cmp     eax, [edi]
        jne     @F

align 4

scan_dword:
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        jmp     scan_dword

align 4 

@@:
        movzx   ecx, WORD PTR ShiftTable[ecx+ecx]
        mov     eax, [esi]              ; get first DWORD to compare
        add     edi, ecx
        mov     ebx, [esp]              ; restore DWORD counter
        cmp     edi, edx                ; check for end of data
        jle     first_dword

no_match:
        or      eax, MINUS_1
        pop     ecx                     ; dump DWORD count
        pop     ebp
        jmp     @Ret

last_bytes:
        mov     ecx, 0fffffffcH
        mov     ebx, ebp
        and     ecx, ebp
        sub     ebx, ecx                ; match_len - whole DWORDs matched so far
        add     esi, ecx
        add     edi, ecx
@@:
        mov     al, BYTE PTR [esi+ebx-1]
        sub     ebx, 1
        js      found
        cmp     [edi+ebx], al
        je      @B

        sub     edi, ecx
        sub     esi, ecx
        add     edi, 1
        mov     eax, [esi]              ; get first DWORD to compare
        mov     ebx, [esp]              ; restore DWORD counter
        jmp     first_dword
    
found:
        pop     edx                     ; dump DWORD count
        sub     edi, ecx
        pop     ebp
        mov     eax, edi
        sub     eax, ebp
@Ret:
        pop     ebx
        pop     edx                     ; return match_len in EDX
        pop     edi
        pop     esi
        ret                             ; return offset of string or -1 if not found

FJT3 endp
FJT3e:
; ------------------------------------------------------------------------------

align 16

FJT4	proc

 comment    * -----------------------------------------------------------------------------
            BM by Cresta rewritten by IanB to use the same entry and exit protocols as
            BInStrWithLen, optimisations including the use of the .DATA? section for the
            ShiftTable, as the extra indexing is slower. Full 4Gb string length searches
            possible with a DWORD-sized shift table.

            On entry:
                EAX = match_len (must be >= 2)
                ECX = lpMatch, pointer to test string
                EDX = DataLen
                EBP = lpData, pointer to source array
                EBX = StartPos offset in lpData
            On exit:
                EAX = string position (from start of source array) or -1 if not found
                EDX = match_len
            EBX/EBP/EDI/ESI are preserved.
            ----------------------------------------------------------------------------- *

        push    esi
        push    edi
        push    eax
        push    ebx
        push    ebp

        cmp     eax, 2                  ; string too short, must be > 1
        jb      no_match
        cmp     eax, MINUS_1            ; string too long, must be < 4Gb-1
        je      no_match

        add	    edx, ebp
        add     ebp, ebx                ; EBP = lpData (including startpos offset if any)
        lea     edi, ShiftTable
        mov     ebx, eax                ; EBX = match_len
        sub	    edx, eax
        add     eax, 1
        mov     esi, ecx                ; ESI = lpMatch
        and     ebx, 0fffffffcH         ; remove remainder bytes over DWORD count
        add     edx, 1                  ; EDX = lpData+DataLen-match_len+1
        mov     ecx, 256
        rep     stosd                   ; fill ShiftTable with match_len+1

        mov     edi, esi
        sub     eax, 1                  ; EAX = match_len
        sub     ebx, 4                  ; EBX = 4 * (count of DWORDs in match string - 1)

put_offset:
        movzx   ecx, BYTE PTR [edi]
        add     edi, 1
        mov     ShiftTable[ecx*4], eax
        sub     eax, 1
        jnz     put_offset

        mov     eax, [esi]              ; get first DWORD to compare
        mov     edi, ebp                ; EDI = lpData + startpos
        mov     ebp, [esp+8]            ; EBP = match_len
        push    ebx                     ; save DWORD counter

align 4    

first_dword:
        movzx   ecx, BYTE PTR [edi+ebp]
        cmp     eax, [edi]
        jne     @F

align 4

scan_dword:
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        mov     eax, [edi+ebx]
        cmp     eax, [esi+ebx]
        jne     @F
        sub     ebx, 4
        js      last_bytes
        jmp     scan_dword

align 4 

@@:
        mov     ecx, ShiftTable[ecx*4]
        mov     eax, [esi]              ; get first DWORD to compare
        add     edi, ecx
        mov     ebx, [esp]              ; restore DWORD counter
        cmp     edi, edx                ; check for end of data
        jle     first_dword

no_match:
        or      eax, MINUS_1
        pop     ecx                     ; dump DWORD count
        pop     ebp
        jmp     @Ret

last_bytes:
        mov     ecx, 0fffffffcH
        mov     ebx, ebp
        and     ecx, ebp
        sub     ebx, ecx                ; match_len - whole DWORDs matched so far
        add     esi, ecx
        add     edi, ecx
@@:
        mov     al, BYTE PTR [esi+ebx-1]
        sub     ebx, 1
        js      found
        cmp     [edi+ebx], al
        je      @B

        sub     edi, ecx
        sub     esi, ecx
        add     edi, 1
        mov     eax, [esi]              ; get first DWORD to compare
        mov     ebx, [esp]              ; restore DWORD counter
        jmp     first_dword
    
found:
        pop     edx                     ; dump DWORD count
        sub     edi, ecx
        pop     ebp
        mov     eax, edi
        sub     eax, ebp
@Ret:
        pop     ebx
        pop     edx                     ; return match_len in EDX
        pop     edi
        pop     esi
        ret                             ; return offset of string or -1 if not found

FJT4 endp

OPTION PROLOGUE:PROLOGUEDEF 
OPTION EPILOGUE:EPILOGUEDEF

;------------------------------------------------------------------------	;
;________________________________________________	;
comment	* BM by Lingo *			
option		prologue:none						; turn it off
option		epilogue:none							



align 			16		
db				6  Dup(9)
BMLinDB		proc	lpBuffer:dword, lpSrchPatt:dword, lenSrchPatt:dword
	pop				edx									; return address
	movd			MM2, edi
	pop				eax									; eax->lpBuffer ; ecx->lenSrchPattern
	movd			MM3, esi
	pop				esi									; esi->lpSrchPatt
	movd			MM4, ebx
	pop				ecx									; ecx->lenSrchPattern ;  must be greater than 8!!!
	movd			MM5, ebp
	lea				ebp,	[ecx+1]					; ebp->lenSrchPatt +1
	movd			MM1, esp
	mov				ebx,	[esi]							; ebx->first dword of the SrchPattern
	mov				edi,	esi
	movd			xmm0, ebp		 
	mov				esp,	eax
	punpcklbw	xmm0, xmm0	
	punpcklbw	xmm0, xmm0	 
	pshufd			xmm0, xmm0, 0 
	mov				ebp,	[esi+ecx-4]				; ebp->last dword of the Search Pattern
	mov				edx,	ecx							
	movdqa		oword ptr [tabl+  0*16], xmm0			; xmm0= lenSrchPattern +1
	movdqa		oword ptr [tabl+  1*16], xmm0
	movdqa		oword ptr [tabl+  2*16], xmm0
	movdqa		oword ptr [tabl+  3*16], xmm0
	movdqa		oword ptr [tabl+  4*16], xmm0
	movdqa		oword ptr [tabl+  5*16], xmm0
	movdqa		oword ptr [tabl+  6*16], xmm0
	movdqa		oword ptr [tabl+  7*16], xmm0
	movdqa		oword ptr [tabl+  8*16], xmm0
	movdqa		oword ptr [tabl+  9*16], xmm0
	movdqa		oword ptr [tabl+10*16], xmm0
	movdqa		oword ptr [tabl+11*16], xmm0
	movdqa		oword ptr [tabl+12*16], xmm0
	movdqa		oword ptr [tabl+13*16], xmm0
	movdqa		oword ptr [tabl+14*16], xmm0
	movdqa		oword ptr [tabl+15*16], xmm0
@@:
	movzx			eax,	byte ptr [edi]			 
	add				edi,	1										 
	mov				byte ptr [tabl+eax], cl
	sub				ecx,	1		 
	jne				@b

	movzx			eax,	byte		ptr [esp+edx]	
	pop				ecx
	movzx			eax,	byte	ptr [tabl+eax]
	cmp				ecx,	ebx									
	je					@LastDwdb

BM_LoopDB:
	lea				esp,	[esp+eax-4]
	je					@f
@@:
	movzx			eax,	byte		ptr [esp+edx]		
	pop				ecx											
	movzx			eax,	byte	ptr [tabl+eax]
	cmp				ecx,	ebx									
	je					@LastDwdb
	lea				esp,	[esp+eax-4]
	jne				@b
@LastDwdb:
	cmp				ebp,	[esp+edx-8]	        			
	jne				BM_LoopDB			
	mov				edi,	[edx+esi-8] 
	db				2Eh											; cs:
	lea				ecx,	[edx-8]	
	cmp     			[ecx+esp-4],	edi 
	jne				BM_LoopDB
@@:
	add				ecx,	-4 
	jle					@f
	mov				edi, 	[ecx+esp-4] 
	cmp				edi,	[ecx+esi] 
	jne				BM_LoopDB
	add				ecx,	-4 
	jle					@f
	mov				edi, 	[ecx+esp-4] 
	cmp				edi,	[ecx+esi] 
	jne				BM_LoopDB
	add				ecx,	-4 
	jle					@f
	mov				edi, 	[ecx+esp-4] 
	cmp				edi,	[ecx+esi] 
	jne				BM_LoopDB
	add				ecx,	-4 
	jle					@f
	mov				edi, 	[ecx+esp-4] 
	cmp				edi,	[ecx+esi] 
	jne				BM_LoopDB
	add				ecx,	-4 
	jle					@f
	mov				edi, 	[ecx+esp-4] 
	cmp				edi,	[ecx+esi] 
	jne				BM_LoopDB
	add				ecx,	-4 
	jle					@f
	mov				edi, 	[ecx+esp-4] 
	cmp				edi,	[ecx+esi] 
	jne				BM_LoopDB
	je					@b
align 16
@@:
	cmp				esp,	esi						; esi-> address of the SrchPattern(after end of the buffer)
	lea				ecx,	[esp-4]					; esp-> current offset in the buffer
	sbb				eax,	eax
	movd			esp,	MM1					; restore registers
	movd			edi,	MM2
	movd			esi,	MM3
	movd			ebx,	MM4
	movd			ebp,	MM5
	sub				ecx,	[esp-3*4]				; [esp-3*4] -> lpBuffer
	and				eax,	ecx						; eax= offset in the buffer or zero	
	jmp	 			dword ptr [esp-4*4]		; jmp to return address
BMLinDB		endp		
BMLinDBe:

align 			16		
db				4	Dup(9)
BMLinDW		proc	lpBuffer:dword, lpSrchPatt:dword, lenSrchPatt:dword
	pop				edx									; return address
	movd			MM2, edi
	pop				eax									; eax->lpBuffer ; ecx->lenSrchPattern
	movd			MM3, esi
	pop				esi									; esi->lpSrchPatt
	movd			MM4, ebx
	pop				ecx									; ecx->lenSrchPattern ;  must be greater than 8!!!
	movd			MM5, ebp
	lea				ebp,	[ecx+1]				; ebp->lenSrchPatt +1
	movd			MM1, esp
	mov				ebx,	[esi]							; ebx->first dword of the SrchPattern
	mov				edx,	ebp							; ebp->lenSrchPatt +1
	shl				edx,	16
	mov				edi,	esi
	mov				esp,	eax
	add				ebp, edx
	mov				edx,	ecx							
	movd			xmm0,	ebp						  
	pshufd 			xmm0,	xmm0, 0				 
	mov				ebp, [esi+ecx-4]				; ebp->last dword of the Search Pattern
	movdqa		oword ptr [tabl+  0*16], xmm0			; xmm0= lenSrchPattern +1
	movdqa		oword ptr [tabl+  1*16], xmm0
	movdqa		oword ptr [tabl+  2*16], xmm0
	movdqa		oword ptr [tabl+  3*16], xmm0
	movdqa		oword ptr [tabl+  4*16], xmm0
	movdqa		oword ptr [tabl+  5*16], xmm0
	movdqa		oword ptr [tabl+  6*16], xmm0
	movdqa		oword ptr [tabl+  7*16], xmm0
	movdqa		oword ptr [tabl+  8*16], xmm0
	movdqa		oword ptr [tabl+  9*16], xmm0
	movdqa		oword ptr [tabl+10*16], xmm0
	movdqa		oword ptr [tabl+11*16], xmm0
	movdqa		oword ptr [tabl+12*16], xmm0
	movdqa		oword ptr [tabl+13*16], xmm0
	movdqa		oword ptr [tabl+14*16], xmm0
	movdqa		oword ptr [tabl+15*16], xmm0
	movdqa		oword ptr [tabl+16*16], xmm0
	movdqa		oword ptr [tabl+17*16], xmm0
	movdqa		oword ptr [tabl+18*16], xmm0
	movdqa		oword ptr [tabl+19*16], xmm0
	movdqa		oword ptr [tabl+20*16], xmm0
	movdqa		oword ptr [tabl+21*16], xmm0
	movdqa		oword ptr [tabl+22*16], xmm0
	movdqa		oword ptr [tabl+23*16], xmm0
	movdqa		oword ptr [tabl+24*16], xmm0
	movdqa		oword ptr [tabl+25*16], xmm0
	movdqa		oword ptr [tabl+26*16], xmm0
	movdqa		oword ptr [tabl+27*16], xmm0
	movdqa		oword ptr [tabl+28*16], xmm0
	movdqa		oword ptr [tabl+29*16], xmm0
	movdqa		oword ptr [tabl+30*16], xmm0
	movdqa		oword ptr [tabl+31*16], xmm0
@@:
	movzx			eax,	byte ptr [edi]			 
	add				edi,	1										 
	mov				word ptr [tabl+eax+eax], cx
	sub				ecx,	1		 
	jne				@b

	movzx			eax,	byte		ptr [esp+edx]	
	pop				ecx
	movzx			eax,	word	ptr [tabl+eax+eax]
	cmp				ecx,	ebx									
	je					@LastDwdw

BM_LoopDW:
	lea				esp,	[esp+eax-4]
	je					@f
@@:
	movzx			eax,	byte		ptr [esp+edx]		
	pop				ecx											
	movzx			eax,	word	ptr [tabl+eax+eax]
	cmp				ecx,	ebx									
	je					@LastDwdw
	lea				esp,	[esp+eax-4]
	jne				@b
@LastDwdw:
	cmp				ebp,	[esp+edx-8]	        			
	jne				BM_LoopDW			
	mov				edi,	[edx+esi-8] 
	db				2Eh											; cs:
	lea				ecx,	[edx-8]	
	cmp     			[ecx+esp-4],	edi 
	jne				BM_LoopDW
@@:
	add				ecx,	-4 
	jle					@f
	mov				edi, 	[ecx+esp-4] 
	cmp				edi,	[ecx+esi] 
	jne				BM_LoopDW
	add				ecx,	-4 
	jle					@f
	mov				edi, 	[ecx+esp-4] 
	cmp				edi,	[ecx+esi] 
	jne				BM_LoopDW
	add				ecx,	-4 
	jle					@f
	mov				edi, 	[ecx+esp-4] 
	cmp				edi,	[ecx+esi] 
	jne				BM_LoopDW
	add				ecx,	-4 
	jle					@f
	mov				edi, 	[ecx+esp-4] 
	cmp				edi,	[ecx+esi] 
	jne				BM_LoopDW
	add				ecx,	-4 
	jle					@f
	mov				edi, 	[ecx+esp-4] 
	cmp				edi,	[ecx+esi] 
	jne				BM_LoopDW
	add				ecx,	-4 
	jle					@f
	mov				edi, 	[ecx+esp-4] 
	cmp				edi,	[ecx+esi] 
	jne				BM_LoopDW
	je					@b
align 16
@@:
	cmp				esp,	esi						; esi-> address of the SrchPattern(after end of the buffer)
	lea				ecx,	[esp-4]					; esp-> current offset in the buffer
	sbb				eax,	eax
	movd			esp,	MM1					; restore registers
	movd			edi,	MM2
	movd			esi,	MM3
	movd			ebx,	MM4
	movd			ebp,	MM5
	sub				ecx,	[esp-3*4]				; [esp-3*4] -> lpBuffer
	and				eax,	ecx						; eax= offset in the buffer or zero	
	jmp	 			dword ptr [esp-4*4]		; jmp to return address
BMLinDW		endp			

align 			16		
db					11 	Dup(9)
BMLinDD			proc	lpBuffer:dword, lpSrchPatt:dword, lenSrchPatt:dword
	pop				edx									; return address
	movd			MM2, edi
	pop				eax									; eax->lpBuffer ; ecx->lenSrchPattern
	movd			MM3, esi
	pop				esi									; esi->lpSrchPatt
	movd			MM4, ebx
	pop				ecx									; ecx->lenSrchPattern ;  must be greater than 8!!!
	movd			MM5, ebp
	lea				ebp,	[ecx+1-4]					; ebp->lenSrchPatt -3
	mov				edi,	esi
	movd			MM1, esp
	movd			xmm0,	ebp						;  
	mov				ebx,	[esi]							; ebx->first dword of the SrchPattern
	mov				esp, eax
	pshufd 			xmm0,	xmm0, 0				 
	mov				ebp,	[esi+ecx-4]				; ebp->last dword of the Search Pattern
	mov				edx,	ecx							
	movdqa		oword ptr [tabl+  0*16], xmm0			; xmm0= lenSrchPattern -3
	movdqa		oword ptr [tabl+  1*16], xmm0
	movdqa		oword ptr [tabl+  2*16], xmm0
	movdqa		oword ptr [tabl+  3*16], xmm0
	movdqa		oword ptr [tabl+  4*16], xmm0
	movdqa		oword ptr [tabl+  5*16], xmm0
	movdqa		oword ptr [tabl+  6*16], xmm0
	movdqa		oword ptr [tabl+  7*16], xmm0
	movdqa		oword ptr [tabl+  8*16], xmm0
	movdqa		oword ptr [tabl+  9*16], xmm0
	movdqa		oword ptr [tabl+10*16], xmm0
	movdqa		oword ptr [tabl+11*16], xmm0
	movdqa		oword ptr [tabl+12*16], xmm0
	movdqa		oword ptr [tabl+13*16], xmm0
	movdqa		oword ptr [tabl+14*16], xmm0
	movdqa		oword ptr [tabl+15*16], xmm0
	movdqa		oword ptr [tabl+16*16], xmm0
	movdqa		oword ptr [tabl+17*16], xmm0
	movdqa		oword ptr [tabl+18*16], xmm0
	movdqa		oword ptr [tabl+19*16], xmm0
	movdqa		oword ptr [tabl+20*16], xmm0
	movdqa		oword ptr [tabl+21*16], xmm0
	movdqa		oword ptr [tabl+22*16], xmm0
	movdqa		oword ptr [tabl+23*16], xmm0
	movdqa		oword ptr [tabl+24*16], xmm0
	movdqa		oword ptr [tabl+25*16], xmm0
	movdqa		oword ptr [tabl+26*16], xmm0
	movdqa		oword ptr [tabl+27*16], xmm0
	movdqa		oword ptr [tabl+28*16], xmm0
	movdqa		oword ptr [tabl+29*16], xmm0
	movdqa		oword ptr [tabl+30*16], xmm0
	movdqa		oword ptr [tabl+31*16], xmm0
	movdqa		oword ptr [tabl+32*16], xmm0
	movdqa		oword ptr [tabl+33*16], xmm0
	movdqa		oword ptr [tabl+34*16], xmm0
	movdqa		oword ptr [tabl+35*16], xmm0
	movdqa		oword ptr [tabl+36*16], xmm0
	movdqa		oword ptr [tabl+37*16], xmm0
	movdqa		oword ptr [tabl+38*16], xmm0
	movdqa		oword ptr [tabl+39*16], xmm0
	movdqa		oword ptr [tabl+40*16], xmm0
	movdqa		oword ptr [tabl+41*16], xmm0
	movdqa		oword ptr [tabl+42*16], xmm0
	movdqa		oword ptr [tabl+43*16], xmm0
	movdqa		oword ptr [tabl+44*16], xmm0
	movdqa		oword ptr [tabl+45*16], xmm0
	movdqa		oword ptr [tabl+46*16], xmm0
	movdqa		oword ptr [tabl+47*16], xmm0
	movdqa		oword ptr [tabl+48*16], xmm0
	movdqa		oword ptr [tabl+49*16], xmm0
	movdqa		oword ptr [tabl+50*16], xmm0
	movdqa		oword ptr [tabl+51*16], xmm0
	movdqa		oword ptr [tabl+52*16], xmm0
	movdqa		oword ptr [tabl+53*16], xmm0
	movdqa		oword ptr [tabl+54*16], xmm0
	movdqa		oword ptr [tabl+55*16], xmm0
	movdqa		oword ptr [tabl+56*16], xmm0
	movdqa		oword ptr [tabl+57*16], xmm0
	movdqa		oword ptr [tabl+58*16], xmm0
	movdqa		oword ptr [tabl+59*16], xmm0
	movdqa		oword ptr [tabl+60*16], xmm0
	movdqa		oword ptr [tabl+61*16], xmm0
	movdqa		oword ptr [tabl+62*16], xmm0
	movdqa		oword ptr [tabl+63*16], xmm0
@@:
	movzx			eax,	byte ptr [edi]			 
	sub				ecx,	4
	mov				dword ptr [tabl+eax*4], ecx
	add				edi,	1
	add				ecx,	3		 
	jne				@b

	movzx			eax,	byte		ptr [esp+edx+4]	
	pop				ecx
	mov				eax,	dword	ptr [tabl+eax*4]
	cmp				ecx,	ebx									
	je					@LastDw
BM_Loop:
	add				esp, eax
	je					@f
@@:
	movzx			eax,	byte		ptr [esp+edx]		
	pop				ecx											
	mov				eax,	dword	ptr [tabl+eax*4]
	cmp				ecx,	ebx									
	je					@LastDw
	add				esp,  eax
	jne				@b
@LastDw:
	cmp				ebp,	[esp+edx-8]	        			
	jne				BM_Loop			
	mov				edi,	[edx+esi-8] 
	db				2Eh											; cs:
	lea				ecx,	[edx-8]	
	cmp     			[ecx+esp-4],	edi 
	jne				BM_Loop
@@:
	add				ecx,	-4 
	jle					@f
	mov				edi, 	[ecx+esp-4] 
	cmp				edi,	[ecx+esi] 
	jne				BM_Loop
	add				ecx,	-4 
	jle					@f
	mov				edi, 	[ecx+esp-4] 
	cmp				edi,	[ecx+esi] 
	jne				BM_Loop
	add				ecx,	-4 
	jle					@f
	mov				edi, 	[ecx+esp-4] 
	cmp				edi,	[ecx+esi] 
	jne				BM_Loop
	add				ecx,	-4 
	jle					@f
	mov				edi, 	[ecx+esp-4] 
	cmp				edi,	[ecx+esi] 
	jne				BM_Loop
	add				ecx,	-4 
	jle					@f
	mov				edi, 	[ecx+esp-4] 
	cmp				edi,	[ecx+esi] 
	jne				BM_Loop
	add				ecx,	-4 
	jle					@f
	mov				edi, 	[ecx+esp-4] 
	cmp				edi,	[ecx+esi] 
	jne				BM_Loop
	je					@b
align 16
@@:
	cmp				esp,	esi						; esi-> address of the SrchPattern(after end of the buffer)
	lea				ecx,	[esp-4]					; esp-> current offset in the buffer
	sbb				eax,	eax
	movd			esp,	MM1					; restore registers
	movd			edi,	MM2
	movd			esi,	MM3
	movd			ebx,	MM4
	movd			ebp,	MM5
	sub				ecx,	[esp-3*4]				; [esp-3*4] -> lpBuffer
	and				eax,	ecx						; eax= offset in the buffer or zero	
	jmp	 			dword ptr [esp-4*4]		; jmp to return address
BMLinDD		endp

align 16
InstrJJ proc StartPos:DWORD, lpSource:DWORD, lpPattern:DWORD, sMode:DWORD
	push esi
	push edi
	push ebx					; all registers preserved, except eax = return value
	push ebp
	push ecx
	push edx
;	and tjj1, 0						; may be used for testing
;	and tjj2, 0
	mov esi, [esp+6*4+2*4]		; lpSource
	mov edx, [esp+6*4+3*4]		; lpPattern
	movzx eax, word ptr [edx]	; 3 cycles to fill xmm3 with first word
	test ah, ah
	je ByteScan
	imul eax, 00010001h			; propagate loword
	movd xmm3, eax
	pshufd xmm3, xmm3, 0		; xmm3 holds first word of pattern
	mov edi, [edx+2]				; next 4 bytes of pattern
	mov eax, edi
	or ebx, -1
	.if al==0
		xor ebx, ebx				; byte 3 is zero
		mov edi, ebx
	.elseif ah==0
		movzx ebx, bl				; byte 4 is zero
		and edi, ebx
	.else
		shr eax, 16
		.if al==0
			movzx ebx, bx		; byte 5 is zero (= and ebx, 0FFFFh)
		.elseif ah==0
			and ebx, 0ffffffh		; byte 6 is zero 
		.endif
	.endif
	and edi, ebx					; apply mask for bytes 2-5
;	movzx eax, word ptr [edx]	; 3 cycles to fill xmm3 with first word
;	imul eax, 00010001h			; propagate loword
;	movd xmm3, eax
;	pshufd xmm3, xmm3, 0		; xmm3 holds first word of pattern
	test esi, 15						; aligned?
	je L0							; if aligned, clear ebp and go directly into the main loop
	movups xmm1, [esi]			; load 16 bytes from current unaligned address
	movups xmm4, [esi+1]		; load another16 bytes
	mov ebp, esi					; save unaligned address
	and esi, -16						; align esi downwards
	jmp @F
;	REPEAT 5						; 5 nops = 20 cycles less?? 0: 3150  1:3142  2:3146  3:3148  4:3144  5: 3132/3151/3142/3155
;		nop
;	ENDM
L0:	xor ebp, ebp
L1:	movaps xmm1, [esi]			; load 16 bytes from current aligned address
	movups xmm4, [esi+1]		; load another 16 bytes
	; xor ebp, ebp					; zero the remainder in first aligned loop
@@:	movaps xmm2, xmm1			; save 16 bytes for testing the zero delimiter
	lea esi, [esi+16]				; len counter (moving up/down lea or add costs cycles)
	; inc tjj1
	; add esi, 16					; ca. 8 cycles slower on P4
	pcmpeqw xmm1, xmm3		; compare packed bytes in xmm1 and xmm3 (elephant) for equality
	pcmpeqb xmm2, xmm1		; xmm1 is filled with either 0 or FF; if it's FF, the byte at that position cannot be zero
	pcmpeqw xmm4, xmm3		; compare packed bytes in xmm4 and xmm3 (elephant) for equality
	pmovmskb edx, xmm1		; set byte mask in edx for search pattern word
	pmovmskb eax, xmm2		; set byte mask in ecx for zero delimiter
	pmovmskb ecx, xmm4			; set byte mask in edx for search pattern word
	shl ecx, 1						; adjust for esi+1 (add ecx, ecx is a lot slower)
	test eax, eax					; zero byte found?
	jnz @F							; check ebp, then ChkNull
	or edx, ecx						; one of them needs to have the word
	jz L1							; 0=no pattern byte found, go back

@@:	test ebp, ebp					; 0=never unaligned, or second loop
	je @F							; ebp=16*n+1....15 ->esi=16*n+16, i.e. esi>ebp
	add ebp, 16
	.if ebp<esi						; at least second loop
		xor ebp, ebp
	.endif
	and ebp, 15

@@:	test eax, eax
	jnz ChkNull

@@:	bsf ecx, edx						; bit scan for the index --------------------------
	lea eax, [esi+ecx-15]
	mov eax, [eax+ebp+1]			; first unaligned chunk contains match
	btr edx, ecx						; clear bit ecx in edx
	and eax, ebx
	cmp eax, edi
	je FoundPattern
BadLuck:
	xor ebp, ebp
	test edx, edx
	jnz @B						; bit scan end ------------------------------------------
	jmp L1						; 0=no more hits in these 16 bytes, go back searching (reversing order is somewhat slower)

ChkNull:
	mov ebx, eax				; position of zero byte
	xor eax, eax				; default: 0=no match
	or edx, ecx					; one of them needs to have the word
	je NoMatch
	bsf ebx, ebx				; nullbyte index in ebx
	bsf ecx, edx					; pattern word index in ecx
	cmp ebx, ecx				; null before pattern word: outta here
	jb NoMatch
	cmp [esi+ecx-14], edi		; what if edi==0???
	jne NoMatch				; first dword after first word doesn't match, so get out

FoundPattern:						; we need to check the complete string here
	test edi, edi					; one-word pattern?
	je Match
	push edi
	push esi
	mov edi, [esp+6*4+3*4+8]		; lpPattern
	lea esi, [esi+ecx-16]
	add esi, ebp

@@:	inc edi
	inc esi
	movzx eax, byte ptr [edi]
	test eax, eax
	je @F
	cmp al, byte ptr [esi]
	je @B

@@:	pop esi
	pop edi
	test eax, eax
	jne BadLuck
	; mov eax, tjj1	; test var 1
	; mov edx, tjj2	; test var 2
Match:
	sub esi, [esp+6*4+2*4]	; lpSource: subtract original src pointer
	lea eax, [esi+ecx-15]		; and adjust for the index
	add eax, ebp				; ebp = offset in first unaligned chunk

NoMatch:
	pop edx		; 6 registers
	pop ecx
	pop ebp
	pop ebx
	pop edi
	pop esi
	; dec eax
	ret 4*4		; 4 arguments

ByteScan:
	; int 3
	imul eax, 01010101h			; propagate lobyte
	movd xmm3, eax
	pshufd xmm3, xmm3, 0		; xmm3 holds first word of pattern
@@:	movups xmm1, [esi]			; load 16 bytes from current aligned address
	movaps xmm2, xmm1			; save 16 bytes for testing the zero delimiter
	lea esi, [esi+16]				; len counter (moving up/down lea or add costs cycles)
	pcmpeqb xmm1, xmm3		; compare packed bytes in xmm1 and xmm3 (elephant) for equality
	pcmpeqb xmm2, xmm1		; xmm1 is filled with either 0 or FF; if it's FF, the byte at that position cannot be zero
	pmovmskb edx, xmm1		; set byte mask in edx for search pattern word
	pmovmskb ecx, xmm2		; set byte mask in ecx for zero delimiter
	test ecx, ecx					; zero byte found?
	jnz @F							; check ebp, then ChkNull
	test edx, edx					; pattern found?
	jz @B							; 0=no pattern byte found, go back

@@:	xor eax, eax
	bsf ecx, ecx
	bsf edx, edx
	cmp ecx, edx
	ja NoMatch
	lea eax, [esi+edx-15]
	sub eax, [esp+6*4+2*4]
	jmp NoMatch

InstrJJ endp
InstrJJe:

option		prologue:prologuedef	; turn back on the defaults
option		epilogue:epiloguedef	;

WinInc proc
	invoke read_disk_file, chr$("\masm32\include\windows.inc"), offset fbuffer, offset flen
	.if eax

		print chr$(13, 10, "Lib InString:", 9)
		counter_begin 1000, HIGH_PRIORITY_CLASS
			invoke InString, 1, fbuffer, offset FindInWinInc
			mov edi, eax
		counter_end
		mov ebx, eax
		print str$(edi)
		print chr$("		; clocks: ")
		print ustr$(ebx)
		invoke Sleep, 250

		print chr$(13, 10, "FJT3:       ", 9)
		mov matchlen, sizeof FindInWinInc-1
		mov sourcelen, len(fbuffer)
		push ebp

;            On entry:
;                EAX = match_len (must be >= 2 and < 65535)
;                ECX = lpMatch, pointer to test string
;                EDX = DataLen
;                EBP = lpData, pointer to source array
;                EBX = StartPos offset in lpData

		counter_begin 1000, HIGH_PRIORITY_CLASS
			mov eax, matchlen
			mov edx, sourcelen
			lea ecx, FindInWinInc
			mov ebp, fbuffer
			xor ebx, ebx		; startpos
			invoke FJT3
			mov edi, eax
		counter_end
		pop ebp
		mov ebx, eax
		print str$(edi)
		print chr$("		; clocks: ")
		print ustr$(ebx)
		invoke Sleep, 250

if 1		; set to 0 for tests without match

		print chr$(13, 10, "BMLinDB: ", 9)
		counter_begin 1000, HIGH_PRIORITY_CLASS
			invoke BMLinDB, fbuffer, offset FindInWinInc, sizeof FindInWinInc-1
			mov edi, eax
		counter_end
		mov ebx, eax
		print str$(edi)
		print chr$("		; clocks: ")
		print ustr$(ebx)
		invoke Sleep, 250

		print chr$(13, 10, "BMLinDW: ", 9)
		counter_begin 1000, HIGH_PRIORITY_CLASS
			invoke BMLinDW, fbuffer, offset FindInWinInc, sizeof FindInWinInc-1
			mov edi, eax
		counter_end
		mov ebx, eax
		print str$(edi)
		print chr$("		; clocks: ")
		print ustr$(ebx)
		invoke Sleep, 250

		print chr$(13, 10, "BMLinDD: ", 9)
		counter_begin 1000, HIGH_PRIORITY_CLASS
			invoke BMLinDD, fbuffer, offset FindInWinInc, sizeof FindInWinInc-1
			mov edi, eax
		counter_end
		mov ebx, eax
		print str$(edi)
		print chr$("		; clocks: ")
		print ustr$(ebx)
		invoke Sleep, 250
endif
		print chr$(13, 10, "InstrJJ: ", 9)
		counter_begin 1000, HIGH_PRIORITY_CLASS
			invoke InstrJJ, 1, fbuffer, offset FindInWinInc, 0
			mov edi, eax
		counter_end
		mov ebx, eax
		print str$(edi)
		print chr$("		; clocks: ")
		print ustr$(ebx)
		print chr$(13, 10, 10)

		invoke GlobalFree, fbuffer

		print "Code sizes:", 13, 10

		print "FJT3       ", 9,
		mov eax, offset FJT3e-FJT3
		print str$(eax), 13, 10

		print "BMLinDB  ", 9,
		mov eax, offset BMLinDBe-BMLinDB
		print str$(eax), 13, 10

		print "InstrJJ ", 9,
		mov eax, offset InstrJJe-InstrJJ
		print str$(eax), 13, 10
	.endif
	ret
WinInc endp

;___________________________	;

End	Start

OPT_Wait	0
OPT_Assembler	ml
OPT_Tmp2Asm	1
OPT_Res	0
